CFLAGS	= -I c:\gcc-arm\include -c -g -O2 -mthumb-interwork -Wall -ffreestanding
ASFLAGS	= -mthumb-interwork
LDFLAGS	= -L c:\gcc-arm\lib -T gbarom2mb

all : rm.bin

rm.bin : rm.elf
	objcopy -v -O binary rm.elf rm.bin

rm.elf : gfx.o time.o main.o
	ld $(LDFLAGS) -o rm.elf main.o gfx.o time.o -lc -lgcc

main.o : main.c
	gcc $(CFLAGS) main.c

gfx.o : gfx.c
	gcc $(CFLAGS) gfx.c

time.o : time.c
	gcc $(CFLAGS) time.c
