/*
	tile.h

	Tile structures and the like.

	Copyright (C) 2001 Sparkle Game Company
*/

#ifndef __TILE_H__
#define __TILE_H__

#include "sdtypes.h"

/*	GBA_TILE

	A single map entry in the following format:

	F E D C B A 9 8 7 6 5 4 3 2 1 0

	- - - - V H T T T T T T T T T T
*/
typedef u16	GBA_TILE;

#define TILE_INDEX		0x03ff	
#define TILE_H			0x0400
#define TILE_V			0x0800

#endif /* __TILE_H__ */