/*
    timer.h

    Last Coder : Greg

    Last Update : 6/8/01

    Last Changes : Created file.

     2001 Sparkle

    Timers.

*/

#include <allegro.h>
#include "timer.h"

#define MAX_BEATS			1000		/* number of beats before timer is reset */

volatile int timer[10];

void rm_timer_handler1(void);
void rm_timer_handler2(void);
void rm_timer_handler3(void);
void rm_timer_handler4(void);
void rm_timer_handler5(void);
void rm_timer_handler6(void);
void rm_timer_handler7(void);
void rm_timer_handler8(void);
void rm_timer_handler9(void);
void rm_timer_handler10(void);


/* void rm_timer_handler1(void)

	Updates timer.
*/
void rm_timer_handler1(void)
{
	timer[0]++;
}
END_OF_FUNCTION(rm_timer_handler1);


/* void rm_timer_handler2(void)

	Updates timer.
*/
void rm_timer_handler2(void)
{
	timer[1]++;
}
END_OF_FUNCTION(rm_timer_handler2);


/* void rm_timer_handler3(void)

	Updates timer.
*/
void rm_timer_handler3(void)
{
	timer[2]++;
}
END_OF_FUNCTION(rm_timer_handler3);


/* void rm_timer_handler4(void)

	Updates timer.
*/
void rm_timer_handler4(void)
{
	timer[3]++;
}
END_OF_FUNCTION(rm_timer_handler4);


/* void rm_timer_handler5(void)

	Updates timer.
*/
void rm_timer_handler5(void)
{
	timer[4]++;
}
END_OF_FUNCTION(rm_timer_handler5);


/* void rm_timer_handler6(void)

	Updates timer.
*/
void rm_timer_handler6(void)
{
	timer[5]++;
}
END_OF_FUNCTION(rm_timer_handler6);


/* void rm_timer_handler7(void)

	Updates timer.
*/
void rm_timer_handler7(void)
{
	timer[6]++;
}
END_OF_FUNCTION(rm_timer_handler7);


/* void rm_timer_handler8(void)

	Updates timer.
*/
void rm_timer_handler8(void)
{
	timer[7]++;
}
END_OF_FUNCTION(rm_timer_handler8);


/* void rm_timer_handler9(void)

	Updates timer.
*/
void rm_timer_handler9(void)
{
	timer[8]++;
}
END_OF_FUNCTION(rm_timer_handler9);


/* void rm_timer_handler10(void)

	Updates timer.
*/
void rm_timer_handler10(void)
{
	timer[9]++;
}
END_OF_FUNCTION(rm_timer_handler10);


/* void rm_timer_init()

	Sets up the timer routine.
*/

void rm_timer_init()
{
	LOCK_VARIABLE(timer);
	LOCK_FUNCTION(rm_timer_handler1);
	LOCK_FUNCTION(rm_timer_handler2);
	LOCK_FUNCTION(rm_timer_handler3);
	LOCK_FUNCTION(rm_timer_handler4);
	LOCK_FUNCTION(rm_timer_handler5);
	LOCK_FUNCTION(rm_timer_handler6);
	LOCK_FUNCTION(rm_timer_handler7);
	LOCK_FUNCTION(rm_timer_handler8);
	LOCK_FUNCTION(rm_timer_handler9);
	LOCK_FUNCTION(rm_timer_handler10);

	install_int_ex(rm_timer_handler1, BPS_TO_TIMER(1));
	install_int_ex(rm_timer_handler2, BPS_TO_TIMER(3));
	install_int_ex(rm_timer_handler3, BPS_TO_TIMER(5));
	install_int_ex(rm_timer_handler4, BPS_TO_TIMER(7));
	install_int_ex(rm_timer_handler5, BPS_TO_TIMER(10));
	install_int_ex(rm_timer_handler6, BPS_TO_TIMER(15));
	install_int_ex(rm_timer_handler7, BPS_TO_TIMER(20));
	install_int_ex(rm_timer_handler8, BPS_TO_TIMER(30));
	install_int_ex(rm_timer_handler9, BPS_TO_TIMER(45));
	install_int_ex(rm_timer_handler10, BPS_TO_TIMER(60));
}