/*
	main.c

	main()

	Copyright (C) 2001 Sparkle Game Company
*/

#include "sdtypes.h"
#include "gfx.h"
#include "input.h"
#include "tile.h"
#include <stdlib.h>

u8 t1[64] =
{
	13, 13, 13, 13, 13, 13, 13, 13,
	13, 2, 2, 2, 2, 2, 2, 10,
	13, 2, 2, 2, 2, 2, 2, 10,
	13, 2, 2, 2, 2, 2, 2, 10,
	13, 2, 2, 2, 2, 2, 2, 10,
	13, 2, 2, 2, 2, 2, 2, 10,
	13, 2, 2, 2, 2, 2, 2, 10,
	13, 10, 10, 10, 10, 10, 10, 10
};
	

u16 *MAP_ADDRESS	= (u16 *)	0x06003800;
u8 *TILE_ADDRESS	= (u8 *)	0x06000000;


int main(void)
{
	PALETTE pal;
	int i, y, x;

	set_gfx_mode(GFX_MODE0);
	/* enable bg0 */
	

	/* set tile data address to block 0 */
	*((u16 *)BG0_CTRL) |= (0 << BG_TILE_SHIFT);
	/* set map data address to block 8 */
	*((u16 *)BG0_CTRL) |= (7 << BG_MAP_SHIFT);

	for(i = 0; i < 256; i++)
		pal[i] = RGB(rand()%32, rand()%32, rand()%32);

	pal[0] = RGB(0, 0, 0);

	set_bg_palette(pal);
	set_sprite_palette(pal);

	for(i = 0; i < 1024; i++)
		MAP_ADDRESS[i] = 0;

	//for(i = 0; i < 64; i++)
		//*(TILE_ADDRESS + i) = t1[i];
	
	//for(i = 0; i < 32; i++)
	//	TILE_ADDRESS[i] = (t1[i] << 8) + t1[i*2];

//	for(i = 0, y = 0; i < 16; i++, y+=2)
//	{
//		TILE_ADDRESS[i] = (t1[y+1] << 8) + t1[y];
//	}


	//for(i = 0; i < 64; i++)
	//	TILE_ADDRESS[i] = t1[i];
	
	//memcpy(TILE_ADDRESS, t1, sizeof(u8) * 64);

	//for(i = 0; i < 64; i++)
		//*(TILE_ADDRESS + i + 64) = t1[i];

	
	for(i = 0; i < 64; i++)
	TILE_ADDRESS[i] = t1[i];
	*((u32 *)DISPLAY_CTRL) |= BG0_ENABLE;

	while(1)
	{
		
	}

	return 0;
}
