/*
	main.c

	main()

	Copyright (C) 2001 Sparkle Game Company
*/

#include "sdtypes.h"
#include "gfx.h"
#include "input.h"
#include "tile.h"
#include <stdlib.h>
#include <string.h>
#include "vfs.h"

u8 t1[64] =
{
	13, 13, 13, 13, 13, 13, 13, 10,
	13, 2, 2, 2, 2, 2, 2, 10,
	13, 2, 2, 2, 2, 2, 2, 10,
	13, 2, 2, 2, 2, 2, 2, 10,
	13, 2, 2, 2, 2, 2, 2, 10,
	13, 2, 2, 2, 2, 2, 2, 10,
	13, 2, 2, 2, 2, 2, 2, 10,
	10, 10, 10, 10, 10, 10, 10, 10
};
	

u16 *MAP_ADDRESS	= (u16 *)	0x06004000;
u16 *TILE_ADDRESS	= (u16 *)	0x06000000;


int main(void)
{
	u32 handle;
	PALETTE pal;
	u16 i;
	
	set_gfx_mode(GFX_MODE0);
	/* enable bg0 */
	
	/* set tile data address to block 0 */
	*((u16 *)BG0_CTRL) |= (0 << BG_TILE_SHIFT);
	/* set map data address to block 8 */
	*((u16 *)BG0_CTRL) |= (8 << BG_MAP_SHIFT);
	*((u16 *)BG0_CTRL) |= BG_256COLOR;

	handle = vfs_fopen("readme.txt");
	
	for(i = 0; i<256; i++)
		pal[i] = RGB(rand()%32, rand()%32, rand()%32);

	pal[0] = RGB(0, 0, 0);

	set_bg_palette(pal);
	set_sprite_palette(pal);


	for(i = 0; i < 1024; i++)
		MAP_ADDRESS[i] = 0;

	
	if(*((u32 *)handle) ==  0x08001a02)   // 0x001a = 1st 16 bit value; 0x0802 = 2nd 16 bit value
		memcpy(TILE_ADDRESS, t1, 64);
	//for(i=0; i<64; i+=2)
	//{
	//	*TILE_ADDRESS = ( t1[i] |    ( t1[ i+1 ] << 8 )  );
	//	TILE_ADDRESS++;
	//}

		
	enable_bg0();
	
	while(1)
	{
	}

	return 0;
}
