/*
	vfs.h

	Virtual file system i/o.

	Copyright (C) 2001 Sparkle Game Company
*/

#ifndef VFS_H
#define VFS_H

#include "sdtypes.h"

/* 
	Comment out the following lines if you wish to save a little cpu time for each file
	being opened.  The trade-off is that you'll manually have to convert spaces to x's
	and the .'s to _'s.
*/
#define CONVERT_FILENAMES

/* 
	PADDED_TO is the first padding value that was selected in vfs.exe.  Right now it's 
	set to 128 kbyte. 
*/
#define PADDED_TO	131072L

u32	vfs_fopen(char *file);

#endif /* VFS_H */