/*
    main.c

    Last Coder : Greg

    Last Update : 6/8/01

    Last Changes : Created file.

     2001 Sparkle

    Contains main().

*/


#include <allegro.h>
#include <string.h>
#include "init.h"
#include "animation.h"
#include "timer.h"
#include "sprite.h"
#include "sound.h"
#include "shutdown.h"
#include "display.h"



/* int main(...) */

int main()
{
	SOUND s;
	SPRITE *s1;
	rm_init();

	s1 = rm_sprite_create("anim.bmp", 5, 2, 0, 0);
	rm_sprite_set_loop(s1, 1);

	rm_sound_load("villagegm.mid", &s);
	rm_sound_loop(&s);

	rm_display_all();
	
	while(!key[KEY_ESC])
	{
		if(key[KEY_UP] && s1->y > 0)
			s1->y--;
		if(key[KEY_DOWN] && s1->y < 140)
			s1->y++;
		if(key[KEY_RIGHT] && s1->x < 200)
			s1->x++;
		if(key[KEY_LEFT] && s1->x > 0)
			s1->x--;
		
		if(key[KEY_O])
		{
			rm_display_fade_out();
			clear_keybuf();
		}

		if(key[KEY_I])
		{
			rm_display_fade_in();
			clear_keybuf();
		}
		
		rm_sprite_animate(s1);
		rectfill(gba_screen, 0, 0, 239, 159, makecol(255, 255, 255));
		rm_sprite_draw(gba_screen, s1);
				
		rm_display_draw();
		poll_keyboard();
	}

	rm_shutdown();
	return 0;
}
END_OF_MAIN()